/* evtgen miscellaneous utilities.
   Copyright (C) 2003 Julien Olivain and LSV, CNRS UMR 8643 & ENS Cachan.

   This file is part of evtgen.

   evtgen is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   evtgen is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with evtgen; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * util.c
 **/


#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>

#include "evtgen.h"

void *
xzmalloc(size_t size)
{
  void *ptr;

  ptr = malloc(size);
  if (!ptr)
    {
      perror("malloc()");
      exit(EXIT_FAILURE);
    }
  memset(ptr, 0, size);

  return (ptr);
}

void *
xmalloc(size_t size)
{
  void *ptr;

  ptr = malloc(size);
  if (!ptr)
    {
      perror("malloc()");
      exit(EXIT_FAILURE);
    }

  return (ptr);
}

void *
xrealloc(void *ptr, size_t size)
{
  void *new_ptr;

  new_ptr = realloc(ptr, size);
  if (!new_ptr)
    {
      perror("realloc()");
      exit(EXIT_FAILURE);
    }

  return (new_ptr);
}

FILE *
xfopen(const char *filename, const char *mode)
{
  FILE *fp;

  if ( (fp = fopen(filename, mode)) == NULL)
    {
      perror("fopen()");
      exit(EXIT_FAILURE);
    }

  return(fp);
}
